INCLUDE(FindPackageHandleStandardArgs)

PKG_CHECK_MODULES(PC_Cmocka QUIET cmocka)

FIND_LIBRARY(Cmocka_LIBRARY
  NAMES cmocka
  PATHS ${PC_Cmocka_LIBRARY_DIRS}
)
FIND_PATH(Cmocka_INCLUDE_DIR
  NAMES cmocka.h
  PATHS ${PC_Cmocka_INCLUDE_DIRS}
)

SET(Cmocka_VERSION ${PC_Cmocka_VERSION})

FIND_PACKAGE_HANDLE_STANDARD_ARGS(Cmocka
  REQUIRED_VARS Cmocka_LIBRARY Cmocka_INCLUDE_DIR
  VERSION_VAR Cmocka_VERSION
)

IF (Cmocka_FOUND)
  ADD_LIBRARY(l::Cmocka UNKNOWN IMPORTED)
  SET_TARGET_PROPERTIES(l::Cmocka PROPERTIES
    IMPORTED_LOCATION "${Cmocka_LIBRARY}"
    INTERFACE_COMPILE_OPTIONS "${PC_Cmocka_CFLAGS_OTHER}"
    INTERFACE_INCLUDE_DIRECTORIES "${Cmocka_INCLUDE_DIR}"
  )
ENDIF()
